<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<!-- <title>TrustletApiForwarder Class Reference</title> -->
<img align="right" width="300" src="TrustonicLogo.jpg">
</br>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="$relpath/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="$relpath/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.8.6 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="functions.html"><span>Data&#160;Fields</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_trustlet_api_forwarder.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-attribs">Data Fields</a>  </div>
  <div class="headertitle">
<div class="title">TrustletApiForwarder Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>WIN32.  
 <a href="class_trustlet_api_forwarder.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a184902dbe3de58e2775aacdc0e5b9e09"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a184902dbe3de58e2775aacdc0e5b9e09"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a184902dbe3de58e2775aacdc0e5b9e09">usesApiLevel</a> (uint32_t apiLevel)</td></tr>
<tr class="memdesc:a184902dbe3de58e2775aacdc0e5b9e09"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check if the current apiLevel matches the requested one. <br/></td></tr>
<tr class="separator:a184902dbe3de58e2775aacdc0e5b9e09"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cb9e8e29bcd3c2be967692a6e9d151a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a8cb9e8e29bcd3c2be967692a6e9d151a">openTrustletSession</a> (void)</td></tr>
<tr class="memdesc:a8cb9e8e29bcd3c2be967692a6e9d151a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Starts a Trusted Application session and establishes shared memory at D2.  <a href="#a8cb9e8e29bcd3c2be967692a6e9d151a">More...</a><br/></td></tr>
<tr class="separator:a8cb9e8e29bcd3c2be967692a6e9d151a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53f32bb6dfb03aeeb9101b2752a17483"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a53f32bb6dfb03aeeb9101b2752a17483">mapD4ForKey</a> (void)</td></tr>
<tr class="memdesc:a53f32bb6dfb03aeeb9101b2752a17483"><td class="mdescLeft">&#160;</td><td class="mdescRight">Maps shared memory at D3.  <a href="#a53f32bb6dfb03aeeb9101b2752a17483">More...</a><br/></td></tr>
<tr class="separator:a53f32bb6dfb03aeeb9101b2752a17483"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a58e800081418a108b33539e8972ec8e6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a58e800081418a108b33539e8972ec8e6">unmapD4ForKey</a> (void)</td></tr>
<tr class="memdesc:a58e800081418a108b33539e8972ec8e6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Unmaps shared memory at D3.  <a href="#a58e800081418a108b33539e8972ec8e6">More...</a><br/></td></tr>
<tr class="separator:a58e800081418a108b33539e8972ec8e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a105585e29183a7be83735acd881ef585"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a105585e29183a7be83735acd881ef585">teardownTrustletSession</a> (void)</td></tr>
<tr class="memdesc:a105585e29183a7be83735acd881ef585"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close a Trusted Application session and unmap existing mappings beforehand.  <a href="#a105585e29183a7be83735acd881ef585">More...</a><br/></td></tr>
<tr class="separator:a105585e29183a7be83735acd881ef585"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75dbff5b7c2c889050e2c49172679905"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a75dbff5b7c2c889050e2c49172679905"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a75dbff5b7c2c889050e2c49172679905">teardown</a> (void)</td></tr>
<tr class="memdesc:a75dbff5b7c2c889050e2c49172679905"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the Trusted Application session and free all allocated resources. <br/></td></tr>
<tr class="separator:a75dbff5b7c2c889050e2c49172679905"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7ac302ddbe4cb38e15480a3f5373277"><td class="memItemLeft" align="right" valign="top">tlApiResult_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#ad7ac302ddbe4cb38e15480a3f5373277">executeCrypto</a> (void)</td></tr>
<tr class="memdesc:ad7ac302ddbe4cb38e15480a3f5373277"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message to Trusted Application, instructing it to use Crypto.  <a href="#ad7ac302ddbe4cb38e15480a3f5373277">More...</a><br/></td></tr>
<tr class="separator:ad7ac302ddbe4cb38e15480a3f5373277"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad405ee4ff323dc781029bba6ef82c1eb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#ad405ee4ff323dc781029bba6ef82c1eb">executeExitTrustlet</a> (void)</td></tr>
<tr class="memdesc:ad405ee4ff323dc781029bba6ef82c1eb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message to Trusted Application, instructing it to exit.  <a href="#ad405ee4ff323dc781029bba6ef82c1eb">More...</a><br/></td></tr>
<tr class="separator:ad405ee4ff323dc781029bba6ef82c1eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab7f2e8ae2df024f49dde8bca98b41dbc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#ab7f2e8ae2df024f49dde8bca98b41dbc">executeCrashTrustlet</a> (void)</td></tr>
<tr class="memdesc:ab7f2e8ae2df024f49dde8bca98b41dbc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message to Trusted Application, instructing it to crash.  <a href="#ab7f2e8ae2df024f49dde8bca98b41dbc">More...</a><br/></td></tr>
<tr class="separator:ab7f2e8ae2df024f49dde8bca98b41dbc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd99314747051a704908a4f5304ddd0d"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#acd99314747051a704908a4f5304ddd0d">svc</a> (uint32_t syscallno, uint32_t *reg0, uint32_t *reg1, uint32_t *reg2, uint32_t *reg3, uint32_t *reg4, mcResult_t *fromMcWaitNotification, int32_t *sessionErrorCode)</td></tr>
<tr class="memdesc:acd99314747051a704908a4f5304ddd0d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message to Trusted Application, instructing it to call svc with given parameters.  <a href="#acd99314747051a704908a4f5304ddd0d">More...</a><br/></td></tr>
<tr class="separator:acd99314747051a704908a4f5304ddd0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c547e173724e128ef0237ad08771585"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a5c547e173724e128ef0237ad08771585">ipc</a> (uint32_t *partner, uint32_t *mr0, uint32_t *mr1, uint32_t *mr2, uint32_t ctrl)</td></tr>
<tr class="memdesc:a5c547e173724e128ef0237ad08771585"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a message to Trusted Application, instructing it to call ipc with given parameters.  <a href="#a5c547e173724e128ef0237ad08771585">More...</a><br/></td></tr>
<tr class="separator:a5c547e173724e128ef0237ad08771585"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab6eea54b2ef7ae3830a82c4dec92ca62"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab6eea54b2ef7ae3830a82c4dec92ca62"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#ab6eea54b2ef7ae3830a82c4dec92ca62">restartTrustletSession</a> (uint32_t apiLevel=3)</td></tr>
<tr class="memdesc:ab6eea54b2ef7ae3830a82c4dec92ca62"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close a Trusted Application session and then starts a Trusted Application session. <br/></td></tr>
<tr class="separator:ab6eea54b2ef7ae3830a82c4dec92ca62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f236c577a73e2d17f373a0ca3bdcbf6"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a1f236c577a73e2d17f373a0ca3bdcbf6">allocOnSharedMemD2</a> (size_t size)</td></tr>
<tr class="memdesc:a1f236c577a73e2d17f373a0ca3bdcbf6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reserve a portion of shared memory D2.  <a href="#a1f236c577a73e2d17f373a0ca3bdcbf6">More...</a><br/></td></tr>
<tr class="separator:a1f236c577a73e2d17f373a0ca3bdcbf6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f056dc8b9fdbfb8e11f09ffe8d6e16d"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a9f056dc8b9fdbfb8e11f09ffe8d6e16d">allocOnSharedMemD3</a> (size_t size)</td></tr>
<tr class="memdesc:a9f056dc8b9fdbfb8e11f09ffe8d6e16d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reserve a portion of shared memory D3.  <a href="#a9f056dc8b9fdbfb8e11f09ffe8d6e16d">More...</a><br/></td></tr>
<tr class="separator:a9f056dc8b9fdbfb8e11f09ffe8d6e16d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2eae818932e52c06061dd40ccbffad20"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2eae818932e52c06061dd40ccbffad20"></a>
uint8_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a2eae818932e52c06061dd40ccbffad20">getBuf</a> ()</td></tr>
<tr class="memdesc:a2eae818932e52c06061dd40ccbffad20"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return address of bulkBuf. <br/></td></tr>
<tr class="separator:a2eae818932e52c06061dd40ccbffad20"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91d6dcb4b4e4637a63aacf87b53132d0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a91d6dcb4b4e4637a63aacf87b53132d0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a91d6dcb4b4e4637a63aacf87b53132d0">freeAll</a> ()</td></tr>
<tr class="memdesc:a91d6dcb4b4e4637a63aacf87b53132d0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset reservations of shared memory. <br/></td></tr>
<tr class="separator:a91d6dcb4b4e4637a63aacf87b53132d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e005f9caa3db4f68ce466a20734e61d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1e005f9caa3db4f68ce466a20734e61d"></a>
mcSessionHandle_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a1e005f9caa3db4f68ce466a20734e61d">getSessionHandle</a> ()</td></tr>
<tr class="memdesc:a1e005f9caa3db4f68ce466a20734e61d"><td class="mdescLeft">&#160;</td><td class="mdescRight">return sessionHandle pointer. <br/></td></tr>
<tr class="separator:a1e005f9caa3db4f68ce466a20734e61d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a99e868375b7229c75c669811d103df07"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_trustlet_api_forwarder.html">TrustletApiForwarder</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a99e868375b7229c75c669811d103df07">getInstance</a> (uint32_t apiLevel=3)</td></tr>
<tr class="memdesc:a99e868375b7229c75c669811d103df07"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the instance of the Trusted Application forwarder.  <a href="#a99e868375b7229c75c669811d103df07">More...</a><br/></td></tr>
<tr class="separator:a99e868375b7229c75c669811d103df07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a877a42ffe3142cacacef13c0684958e4"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_trustlet_api_forwarder.html">TrustletApiForwarder</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a877a42ffe3142cacacef13c0684958e4">getSingleInstance</a> (uint32_t apiLevel=3)</td></tr>
<tr class="memdesc:a877a42ffe3142cacacef13c0684958e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the instance of the Trusted Application forwarder.  <a href="#a877a42ffe3142cacacef13c0684958e4">More...</a><br/></td></tr>
<tr class="separator:a877a42ffe3142cacacef13c0684958e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac11885b3495a12f7622fb007b56add5d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac11885b3495a12f7622fb007b56add5d"></a>
static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#ac11885b3495a12f7622fb007b56add5d">ensureNotUsed</a> (void)</td></tr>
<tr class="memdesc:ac11885b3495a12f7622fb007b56add5d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Ensure that no Kinibi resources are bound by <a class="el" href="class_trustlet_api_forwarder.html" title="WIN32. ">TrustletApiForwarder</a>. <br/></td></tr>
<tr class="separator:ac11885b3495a12f7622fb007b56add5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Data Fields</h2></td></tr>
<tr class="memitem:a3a19b565f331ffc24af2a2b396e966a7"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#a3a19b565f331ffc24af2a2b396e966a7">sessionError</a></td></tr>
<tr class="memdesc:a3a19b565f331ffc24af2a2b396e966a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Error from last svc call, can be queried to get TA state.  <a href="#a3a19b565f331ffc24af2a2b396e966a7">More...</a><br/></td></tr>
<tr class="separator:a3a19b565f331ffc24af2a2b396e966a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1e40b6bdbb51fba21538fe76043dff0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae1e40b6bdbb51fba21538fe76043dff0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_trustlet_api_forwarder.html#ae1e40b6bdbb51fba21538fe76043dff0">consumeNotificationInSVC</a></td></tr>
<tr class="memdesc:ae1e40b6bdbb51fba21538fe76043dff0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Consume one notification in <a class="el" href="class_trustlet_api_forwarder.html#acd99314747051a704908a4f5304ddd0d" title="Send a message to Trusted Application, instructing it to call svc with given parameters. ">svc()</a> <br/></td></tr>
<tr class="separator:ae1e40b6bdbb51fba21538fe76043dff0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>WIN32. </p>
<p>A class to manage a legacy TA that executes tlApi functions on behalf of the testcase.</p>
<ul>
<li>Use <a class="el" href="class_trustlet_api_forwarder.html#a99e868375b7229c75c669811d103df07" title="Get the instance of the Trusted Application forwarder. ">TrustletApiForwarder::getInstance()</a> to open the TA during setup()</li>
<li>Use <a class="el" href="class_trustlet_api_forwarder.html#ac11885b3495a12f7622fb007b56add5d" title="Ensure that no Kinibi resources are bound by TrustletApiForwarder. ">TrustletApiForwarder::ensureNotUsed()</a> in <a class="el" href="class_trustlet_api_forwarder.html#a75dbff5b7c2c889050e2c49172679905" title="Close the Trusted Application session and free all allocated resources. ">teardown()</a>. </li>
</ul>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a99e868375b7229c75c669811d103df07"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_trustlet_api_forwarder.html">TrustletApiForwarder</a> * getInstance </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>apiLevel</em> = <code>3</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the instance of the Trusted Application forwarder. </p>
<p>If necessary, creates one Instance. Recreates session with TA if apiLevel param is different then the one provided previously. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">apiLevel</td><td>Select the requested TBASE_API_LEVEL of the TA </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TrustletApiForwarder* </dd></dl>

</div>
</div>
<a class="anchor" id="a877a42ffe3142cacacef13c0684958e4"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_trustlet_api_forwarder.html">TrustletApiForwarder</a> * getSingleInstance </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>apiLevel</em> = <code>3</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the instance of the Trusted Application forwarder. </p>
<p>If necessary, creates one Instance. Never recreates session with TA. Returns NULL if apiLevel is different then the one provided on object initialization. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">apiLevel</td><td>Select the requested TBASE_API_LEVEL of the TA </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TrustletApiForwarder* </dd></dl>

</div>
</div>
<a class="anchor" id="a8cb9e8e29bcd3c2be967692a6e9d151a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void openTrustletSession </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Starts a Trusted Application session and establishes shared memory at D2. </p>
<p>Then calls helper for shared memory at D3. Then initializes the allocators. </p>

</div>
</div>
<a class="anchor" id="a53f32bb6dfb03aeeb9101b2752a17483"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mapD4ForKey </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Maps shared memory at D3. </p>
<p>This helper function is used in between Tests to reestablish mappings. </p>

</div>
</div>
<a class="anchor" id="a58e800081418a108b33539e8972ec8e6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void unmapD4ForKey </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Unmaps shared memory at D3. </p>
<p>This helper function is used to remove a mapping in between function calls. If function 1 verifies the mapping and function 2 uses it without verification, Function 2 will trigger a page fault. </p>

</div>
</div>
<a class="anchor" id="a105585e29183a7be83735acd881ef585"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void teardownTrustletSession </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Close a Trusted Application session and unmap existing mappings beforehand. </p>
<p>This helper function is used to close a Trusted Application session inside a Test. This is used to test if crypto sessions are correctly closed when a Trusted Application exits. </p>

</div>
</div>
<a class="anchor" id="ad7ac302ddbe4cb38e15480a3f5373277"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">tlApiResult_t executeCrypto </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a message to Trusted Application, instructing it to use Crypto. </p>
<p>Wait for response and unmarshal result. </p>
<dl class="section return"><dt>Returns</dt><dd>tlApiResult_t </dd></dl>

</div>
</div>
<a class="anchor" id="ad405ee4ff323dc781029bba6ef82c1eb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void executeExitTrustlet </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a message to Trusted Application, instructing it to exit. </p>
<p>Wait for Notification from MC Session management and verify exit code. This helper function is used to close a Trusted Application session inside a Test. This is used to test if crypto sessions are correctly closed when a Trusted Application exits. </p>

</div>
</div>
<a class="anchor" id="ab7f2e8ae2df024f49dde8bca98b41dbc"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void executeCrashTrustlet </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a message to Trusted Application, instructing it to crash. </p>
<p>Wait for Notification from MC Session management and verify exit reason. This helper function is used to close a Trusted Application session inside a Test. This is used to test if crypto sessions are correctly closed when a Trusted Application crashes. </p>

</div>
</div>
<a class="anchor" id="acd99314747051a704908a4f5304ddd0d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t svc </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>syscallno</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>reg0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>reg1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>reg2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>reg3</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>reg4</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">mcResult_t *&#160;</td>
          <td class="paramname"><em>fromMcWaitNotification</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t *&#160;</td>
          <td class="paramname"><em>sessionErrorCode</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a message to Trusted Application, instructing it to call svc with given parameters. </p>
<p>Wait for Notification from Kinibi. Usually, Trusted Application tells us that svc was not successful. However, also, Trusted Application could terminate or maybe crash. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">syscallno</td><td></td></tr>
    <tr><td class="paramname">reg0</td><td></td></tr>
    <tr><td class="paramname">reg1</td><td></td></tr>
    <tr><td class="paramname">reg2</td><td></td></tr>
    <tr><td class="paramname">reg3</td><td></td></tr>
    <tr><td class="paramname">reg4</td><td></td></tr>
    <tr><td class="paramname">fromMcWaitNotification</td><td></td></tr>
    <tr><td class="paramname">sessionErrorCode</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>uint32_t </dd></dl>

</div>
</div>
<a class="anchor" id="a5c547e173724e128ef0237ad08771585"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t ipc </td>
          <td>(</td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>partner</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>mr0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>mr1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>mr2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>ctrl</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a message to Trusted Application, instructing it to call ipc with given parameters. </p>
<p>Based on <a class="el" href="class_trustlet_api_forwarder.html#acd99314747051a704908a4f5304ddd0d" title="Send a message to Trusted Application, instructing it to call svc with given parameters. ">svc()</a>, but does not expect any abnormal behavior. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">partner</td><td></td></tr>
    <tr><td class="paramname">mr0</td><td></td></tr>
    <tr><td class="paramname">mr1</td><td></td></tr>
    <tr><td class="paramname">mr2</td><td></td></tr>
    <tr><td class="paramname">ctrl</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>uint32_t </dd></dl>

</div>
</div>
<a class="anchor" id="a1f236c577a73e2d17f373a0ca3bdcbf6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void * allocOnSharedMemD2 </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reserve a portion of shared memory D2. </p>
<p>The returned address can be used in Trusted Application and TLC. Reservations are stored using a freepointer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">size</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9f056dc8b9fdbfb8e11f09ffe8d6e16d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void * allocOnSharedMemD3 </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reserve a portion of shared memory D3. </p>
<p>The returned address can be used in Trusted Application and TLC. Reservations are stored using a freepointer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">size</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Field Documentation</h2>
<a class="anchor" id="a3a19b565f331ffc24af2a2b396e966a7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t sessionError</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Error from last svc call, can be queried to get TA state. </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
        <br><br>
        <hr>
        <small><em>Copyright (c) 2013-2015 TRUSTONIC LIMITED - TRUSTONIC CONFIDENTIAL</em></small>
    </body>
</html>
